#!/usr/bin/env node
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var madge = require("madge");
var path = require("path");
var packageJSON = require(path.resolve(process.cwd(), "package.json"));
var userConfig = packageJSON["next-unused"] || {};
try {
    main();
}
catch (e) {
    console.error("Error while running next-unused:", e);
}
function main() {
    var debug = userConfig.debug, _a = userConfig.include, include = _a === void 0 ? [] : _a, _b = userConfig.exclude, exclude = _b === void 0 ? [] : _b, _c = userConfig.entrypoints, userEntrypoints = _c === void 0 ? [] : _c;
    if (debug) {
        if (include.length) {
            console.log("[debug] Found include config: " + include);
        }
        if (exclude.length) {
            console.log("[debug] Found exclude config: " + exclude);
        }
        if (userEntrypoints.length) {
            console.log("[debug] Found entrypoints config: " + userEntrypoints);
        }
    }
    for (var _i = 0, userEntrypoints_1 = userEntrypoints; _i < userEntrypoints_1.length; _i++) {
        var entrypoint = userEntrypoints_1[_i];
        if (!include.includes(entrypoint)) {
            include.push(entrypoint);
            if (debug) {
                console.log("[debug] Entrypoint \"" + entrypoint + "\" is missing in includes, adding it");
            }
        }
    }
    var userSearchDirs = include.length ? include.join("|") : "";
    var searchDirs = new RegExp("^(?!(" + (userSearchDirs.includes("pages") ? "" : "pages|") + userSearchDirs + "))", "i");
    if (debug === true) {
        console.log("[debug] Using exclude regex: " + __spreadArrays([searchDirs], exclude));
    }
    madge(process.cwd(), {
        webpackConfig: path.resolve(__dirname, "madge.webpack.js"),
        excludeRegExp: __spreadArrays([searchDirs], exclude),
    }).then(function (res) {
        var tree = res.obj();
        var entrypoints = Object.keys(tree).filter(function (f) {
            return (f.startsWith("pages/") ||
                userEntrypoints.some(function (x) { return f.startsWith(x.includes("/") ? x : x + "/"); }));
        });
        if (debug) {
            console.log("[debug] Found entrypoints");
            console.log(entrypoints);
        }
        if (!entrypoints.length) {
            return console.log("No unused files!");
        }
        pruneTree(entrypoints, tree);
        var unusedFilenames = Object.keys(tree);
        if (!unusedFilenames.length) {
            console.log("No unused files!");
        }
        else {
            console.log("Found " + unusedFilenames.length + " unused " + (unusedFilenames.length === 1 ? "file" : "files") + ":");
            unusedFilenames.map(function (f) { return console.log(f); });
        }
    });
}
function pruneTree(subtree, tree) {
    if (!subtree || subtree.length === 0)
        return;
    for (var _i = 0, subtree_1 = subtree; _i < subtree_1.length; _i++) {
        var child = subtree_1[_i];
        var nextSubtree = tree[child];
        if (tree[child]) {
            delete tree[child];
        }
        pruneTree(nextSubtree, tree);
    }
}
